---
title: Create a Feature
slug: feature-experimentation/api/create-a-feature
docTags: 
createdAt: 2026-10-01T19:58:02.336Z
---

{
  "id": "_6py2XaR20b77G4LEZML6",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.optimizely.com/v2/features",
    "servers": [
      {
        "url": "https://api.optimizely.com/v2/features"
      }
    ],
    "name": "Create a Feature",
    "description": "Create a Feature",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "<p>A string in JSON format that includes all the fields to create a new Feature. Note this endpoint is incompatible with Full Stack Targeted Rollouts projects\n(default in accounts created after July 2020) and with non-legacy Full Stack projects (default in projects created after February 2021).\nSee the compatible API at <a href=\"https://library.optimizely.com/docs/api/flags/v1/index.html#tag/Flags\" target=\"_blank\">https://library.optimizely.com/docs/api/flags/v1/index.html#tag/Flags</a>.</p>",
          "customType": "Feature",
          "schema": [
            {
              "name": "archived",
              "kind": "optional",
              "type": "boolean",
              "description": "Whether the Feature has been archived",
              "default": false
            },
            {
              "name": "description",
              "kind": "optional",
              "type": "string",
              "description": "A short description of this Feature"
            },
            {
              "name": "environments",
              "kind": "optional",
              "type": "map",
              "description": "<p>The configuration for this Feature's Rollout within each Environment, keyed by Environment key</p>",
              "example": "",
              "customType": "map<string, FeatureEnvironment>",
              "schema": []
            },
            {
              "name": "key",
              "kind": "required",
              "type": "string",
              "description": "Unique string identifier for this Feature within the Project",
              "example": "new_checkout_page",
              "maxLength": 64,
              "pattern": "^[a-zA-Z0-9_\\-]+$"
            },
            {
              "name": "name",
              "kind": "optional",
              "type": "string",
              "description": "Name of the Feature",
              "example": "the checkout feature"
            },
            {
              "name": "project_id",
              "kind": "required",
              "type": "integer<int64>",
              "description": "The ID of the Project this Feature belongs to",
              "format": "int64"
            },
            {
              "name": "variables",
              "kind": "optional",
              "type": "array",
              "description": "<p>Variables define the dynamic configuration of a feature, and each variable can take on a different value on a per-variation basis within a feature test.</p>",
              "modelRef": "#/components/schemas/FeatureVariable",
              "customType": "FeatureVariable[]",
              "schema": [
                {
                  "name": "archived",
                  "kind": "optional",
                  "type": "boolean",
                  "description": "Whether or not this Feature Variable is archived",
                  "default": false
                },
                {
                  "name": "default_value",
                  "kind": "required",
                  "type": "string",
                  "description": "The stringified default value for this Feature Variable. The default value is the value Optimizely SDKs will return when this Feature Variable is accessed by getFeatureVariableValue unless the Feature Variable's value is a part of a feature test variation.",
                  "example": "0.05"
                },
                {
                  "name": "id",
                  "kind": "optional",
                  "type": "integer<int64>",
                  "readOnly": true,
                  "description": "The ID of this Feature Variable",
                  "format": "int64"
                },
                {
                  "name": "key",
                  "kind": "required",
                  "type": "string",
                  "description": "Unique string identifier for this Feature Variable within the Feature"
                },
                {
                  "name": "type",
                  "kind": "required",
                  "type": "string<boolean | string | double | integer | json>",
                  "description": "The datatype for this Feature Variable",
                  "example": "double",
                  "enum": [
                    "boolean",
                    "string",
                    "double",
                    "integer",
                    "json"
                  ]
                }
              ]
            }
          ],
          "modelRef": "#/components/schemas/Feature",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "apiKey",
          "name": "apiKey",
          "kind": "optional",
          "type": "http",
          "scheme": "bearer"
        },
        {
          "id": "OAuth2",
          "name": "OAuth2",
          "kind": "optional",
          "type": "oauth2",
          "description": "<p>Write applications that authenticate with the REST API via OAuth 2.0. Or, to authenticate using a personal token, see <a href=\"https://docs.developers.optimizely.com/web/docs/personal-token\" target=\"_blank\">https://docs.developers.optimizely.com/web/docs/personal-token</a></p>",
          "oauth2Flows": {
            "authorizationCode": {
              "authorizationUrl": "https://app.optimizely.com/oauth2/authorize",
              "tokenUrl": "https://app.optimizely.com/oauth2/token",
              "scopes": {
                "all": "Full access to your account"
              }
            }
          },
          "requiredScopes": [
            "read",
            "write"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "201",
        "description": "Successfully created the Feature",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "Feature",
            "schema": [
              {
                "name": "archived",
                "kind": "optional",
                "type": "boolean",
                "description": "Whether the Feature has been archived",
                "default": false
              },
              {
                "name": "created",
                "kind": "optional",
                "type": "string<date-time>",
                "readOnly": true,
                "description": "Time when the Feature was created",
                "format": "date-time"
              },
              {
                "name": "description",
                "kind": "optional",
                "type": "string",
                "description": "A short description of this Feature"
              },
              {
                "name": "environments",
                "kind": "optional",
                "type": "map",
                "description": "<p>The configuration for this Feature's Rollout within each Environment, keyed by Environment key</p>",
                "example": "",
                "customType": "map<string, FeatureEnvironment>",
                "schema": []
              },
              {
                "name": "id",
                "kind": "optional",
                "type": "integer<int64>",
                "readOnly": true,
                "description": "The ID of this Feature",
                "format": "int64"
              },
              {
                "name": "key",
                "kind": "required",
                "type": "string",
                "description": "Unique string identifier for this Feature within the Project",
                "example": "new_checkout_page",
                "maxLength": 64,
                "pattern": "^[a-zA-Z0-9_\\-]+$"
              },
              {
                "name": "last_modified",
                "kind": "optional",
                "type": "string<date-time>",
                "readOnly": true,
                "description": "Date last modified",
                "format": "date-time"
              },
              {
                "name": "name",
                "kind": "optional",
                "type": "string",
                "description": "Name of the Feature",
                "example": "the checkout feature"
              },
              {
                "name": "project_id",
                "kind": "required",
                "type": "integer<int64>",
                "description": "The ID of the Project this Feature belongs to",
                "format": "int64"
              },
              {
                "name": "variables",
                "kind": "optional",
                "type": "array",
                "description": "<p>Variables define the dynamic configuration of a feature, and each variable can take on a different value on a per-variation basis within a feature test.</p>",
                "modelRef": "#/components/schemas/FeatureVariable",
                "customType": "FeatureVariable[]",
                "schema": [
                  {
                    "name": "archived",
                    "kind": "optional",
                    "type": "boolean",
                    "description": "Whether or not this Feature Variable is archived",
                    "default": false
                  },
                  {
                    "name": "default_value",
                    "kind": "required",
                    "type": "string",
                    "description": "The stringified default value for this Feature Variable. The default value is the value Optimizely SDKs will return when this Feature Variable is accessed by getFeatureVariableValue unless the Feature Variable's value is a part of a feature test variation.",
                    "example": "0.05"
                  },
                  {
                    "name": "id",
                    "kind": "optional",
                    "type": "integer<int64>",
                    "readOnly": true,
                    "description": "The ID of this Feature Variable",
                    "format": "int64"
                  },
                  {
                    "name": "key",
                    "kind": "required",
                    "type": "string",
                    "description": "Unique string identifier for this Feature Variable within the Feature"
                  },
                  {
                    "name": "type",
                    "kind": "required",
                    "type": "string<boolean | string | double | integer | json>",
                    "description": "The datatype for this Feature Variable",
                    "example": "double",
                    "enum": [
                      "boolean",
                      "string",
                      "double",
                      "integer",
                      "json"
                    ]
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/Feature",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "Invalid request body content",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "Error",
            "schema": [
              {
                "name": "code",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "message",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "messages",
                "kind": "optional",
                "type": "object",
                "description": "",
                "example": "",
                "schema": []
              },
              {
                "name": "uuid",
                "kind": "optional",
                "type": "string<uuid>",
                "description": "",
                "format": "uuid"
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Invalid credentials",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "Error",
            "schema": [
              {
                "name": "code",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "message",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "messages",
                "kind": "optional",
                "type": "object",
                "description": "",
                "example": "",
                "schema": []
              },
              {
                "name": "uuid",
                "kind": "optional",
                "type": "string<uuid>",
                "description": "",
                "format": "uuid"
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "default",
        "description": "Unexpected error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "Error",
            "schema": [
              {
                "name": "code",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "message",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "messages",
                "kind": "optional",
                "type": "object",
                "description": "",
                "example": "",
                "schema": []
              },
              {
                "name": "uuid",
                "kind": "optional",
                "type": "string<uuid>",
                "description": "",
                "format": "uuid"
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "c78nh6K038dsHR8kGq-_1",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.optimizely.com/v2/features \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"key\": \"new_checkout_page\",\n     \"project_id\": \"\",\n     \"variables\": [\n     {\n     \"default_value\": \"0.05\",\n     \"key\": \"\",\n     \"type\": \"double\"\n     }\n     ]\n     }'"
        },
        {
          "id": "PJSdQalxOKwnCVIbtTCDT",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"key\": \"new_checkout_page\",\n   \"project_id\": \"\",\n   \"variables\": [\n      {\n         \"default_value\": \"0.05\",\n         \"key\": \"\",\n         \"type\": \"double\"\n      }\n   ]\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.optimizely.com/v2/features\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "9-H6FaF7ms7iefdyTg2Kh",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.optimizely.com/v2/features\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"key\": \"new_checkout_page\",\n   \"project_id\": \"\",\n   \"variables\": [\n      {\n         \"default_value\": \"0.05\",\n         \"key\": \"\",\n         \"type\": \"double\"\n      }\n   ]\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "JB8IC-7fvsZliy-cnKa95",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.optimizely.com/v2/features\"\n\npayload = json.dumps({\n   \"key\": \"new_checkout_page\",\n   \"project_id\": \"\",\n   \"variables\": [\n      {\n         \"default_value\": \"0.05\",\n         \"key\": \"\",\n         \"type\": \"double\"\n      }\n   ]\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "c78nh6K038dsHR8kGq-_1"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-201",
          "language": "201",
          "code": "// Successfully created the Feature\n{\n  \"archived\": false,\n  \"created\": \"\",\n  \"description\": \"\",\n  \"environments\": \"\",\n  \"id\": \"\",\n  \"key\": \"new_checkout_page\",\n  \"last_modified\": \"\",\n  \"name\": \"the checkout feature\",\n  \"project_id\": \"\",\n  \"variables\": [\n    {\n      \"archived\": false,\n      \"default_value\": \"0.05\",\n      \"id\": \"\",\n      \"key\": \"\",\n      \"type\": \"double\"\n    }\n  ]\n}"
        },
        {
          "id": "response-1-400",
          "language": "400",
          "code": "// Invalid request body content\n{\n  \"code\": \"\",\n  \"message\": \"\",\n  \"messages\": {},\n  \"uuid\": \"\"\n}"
        },
        {
          "id": "response-2-401",
          "language": "401",
          "code": "// Invalid credentials\n{\n  \"code\": \"\",\n  \"message\": \"\",\n  \"messages\": {},\n  \"uuid\": \"\"\n}"
        },
        {
          "id": "response-3-default",
          "language": "default",
          "code": "// Unexpected error\n{\n  \"code\": \"\",\n  \"message\": \"\",\n  \"messages\": {},\n  \"uuid\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "response-0-201"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}